/*
 * LCOMMON.C, LSYSMGR ե   Copyright 1996, Eiichiroh Itoh
 *
 * :96/02/08:ƣ ɰϺ(GHC02331@niftyserve.or.jp)
 *
 */
/* this file is modified by FURUKAWA Yo (you@ss.iij4u.or.jp) */

#ifndef	__LFUNC
#define	__LFUNC

#ifndef	STRICT
#define	STRICT
#endif	/* STRICT */
#ifndef	UNICODE
#define	UNICODE
#endif	/* UNICODE */
#ifndef	_UNICODE
#define	_UNICODE
#endif	/* _UNICODE */

#include <stdio.h>
#include "portunix.h"

#undef	isalpha

#ifdef	USE_TC
#undef	const
#endif	/* USE_TC */

#define	Assert(p) ((p) ? (void)0 : (void) __assertfail( #p, __FILE__, __LINE__ ) )
#define	Abs(x)		((x)<0?-(x):(x))
#define	toupper(x)	(((x)>='a'&&(x)<='z')?(x)-'a'+'A':(x))
#define	tolower(x)	(((x)>='A'&&(x)<='Z')?(x)-'A'+'a':(x))
#define	isalpha(x)	(((x)>='A'&&(x)<='Z')||((x)>='a'&&(x)<='z'))
#define	iskana(x)	((x)>=0xA0 && (x)<=0xDF)
#define	iskanji(x)	(((x)>=0x81 && (x)<=0x9F)||((x)>=0xE0 && (x)<=0xFC))
#define	CT_ANK		(0)
#define	CT_KJ1		(1)
#define	CT_KJ2		(2)
#define	CT_ILGL		(-1)
#define	MIN_PER_DAY	(24*60)
#define	MIN_PER_4DAY	(96*60)
#define	NORM_MIN(x)	(((x)+MIN_PER_DAY)%MIN_PER_DAY)

/*----------------------------------------------------------------------------
 * ؿ
 *--------------------------------------------------------------------------*/
#ifdef __cplusplus
extern "C" {
#endif

/* ꡦʸؿ */
void	Memset( void *dst, int c, int len ) ;
void	Memcpy( void *dst,void *src, int len ) ;
int		Memcmp(void *x,void *y, int len ) ;
int		Strlen(BYTE *str ) ;
void	Strcpy( LPBYTE dst,BYTE *src ) ;
int		Strcmp(BYTE *x,BYTE *y ) ;
int		Strcmpi(BYTE *x,BYTE *y ) ;
void	StrAppend( BYTE **_dst,BYTE *src ) ;
BYTE	*Strchr(BYTE *p, int cc ) ;
BYTE	*Strichr(BYTE *p, int cc ) ;

/* ǡʸѴؿ */
WORD	Atoi(BYTE *buf ) ;
int		XAtoi(BYTE *buf ) ;
long	Atol(BYTE *buf ) ;
long	XAtol(BYTE *buf ) ;
void	Itoa( int v, BYTE *buf ) ;
void	Itoxa( WORD v, BYTE *buf ) ;
void	Ltoa( long v, BYTE *buf ) ;
void	ItoaN_pad( int v, BYTE *buf, int keta, int pad ) ;
#define	ItoaN( v, b, k )	ItoaN_pad( (v), (b), (k), ' ' )
#define	ItoaZN( v, b, k )	ItoaN_pad( (v), (b), (k), '0' )
int		Isdigit( int c ) ;
int		Isspace( int c ) ;

/* ٥եؿ */
/*int		process_file(BYTE fn[], int (*proc)(BYTE buf[] ) ) ;*/
int process_file( const char fn[], int (*proc)( const char buf[] ) );
int		FreadBuf( void* buf, int size ) ;

/* ٥եؿ */
BOOL	Fexist( LPCTSTR fn ) ;
BOOL	Fopen( LPCTSTR fn, LPCTSTR mode ) ;
int		Fread( void* buf, int size ) ;
WORD	Fread_far( void* buf, WORD size ) ;
int		Fwrite( void* buf, int size ) ;
int		Fwrite_far( void* buf, WORD size ) ;
int		Fwrite_str( void* buf ) ;
int		Fwrite_num( int num ) ;
int		Fwrite_hex( WORD num ) ;
void	Fclose( void ) ;
void	Fseek( long ptr, int whence ) ;
long	Ftell( void ) ;
void	Unlink(BYTE *fn ) ;
int		Rename(BYTE *src,BYTE *dst ) ;
int		Copy(BYTE *src,BYTE *dst ) ;

/* ǥ쥯ȥؿ */
int		FindFirst( BYTE pat[], BYTE fn[] ) ;
int		FindNext( BYTE fn[] ) ;

/* NEAR ؿ */
/* void*	Malloc( int size ) ; */
/* void	Free( void * ) ; */
/* int		LastAlloc() ; */
/* void	InitAlloc( WORD size ) ; */

/* ܸؿ */
void	roma2kana(BYTE *src, LPBYTE _dst ) ;
void	kana2roma(BYTE *src, LPBYTE _dst ) ;
int		nthctype(BYTE *str, int nth ) ;
void	parse(BYTE buf[], int sep, int comment ) ;

void sjis2euc(unsigned char *fromeuc,unsigned char *tosjis);
/*void sjis2euc(unsigned char *string);*/

 BYTE*	han2zen_str(BYTE *src ) ;

/* ʸؿ */
void	StringAllocN( int num_index, WORD num_str ) ;
void	StringFree( void ) ;
int		StringAlloc(BYTE* src ) ;
 BYTE*	StringGet( int index ) ;

/* ٥륯åץܡɴؿ */
int	CBopen( BYTE *name, BYTE *mode ) ;
void	CBwrite( void* buf, int size ) ;
void	CBread( void* buf, int size ) ;
int	CBgetsize( void ) ;
void	CBclose( void ) ;

/* åץܡɴؿ */
int	cb_read( BYTE buf[], int *size ) ;

/* աؿ */
void	get_nowstr( BYTE buf[] ) ;

/* ᡼ɽ */
#define		REP_FORCE	0
#define		REP_AND		1
#define		REP_OR		2
#define		REP_XOR		3
#define		REP_NOTFORCE	4
#define		REP_NOTAND	5
#define		REP_NOTOR	6
#define		REP_NOTXOR	7
#define		REP_BITBLT	8

void	get_image( int x1, int y1, int x2, int y2,BYTE *buf ) ;
void	put_image( int x, int y,BYTE *buf, int reprule ) ;
void	HourglassOn( int x, int y ) ;
void	HourglassOff( void ) ;

/* åؿ */
void	read_msg(BYTE *fn ) ;
BYTE*	get_msg( int kind, int idx ) ;
void	fatal_msg( int idx ) ;

/* ¾ؿ */
int	parse_time(BYTE *timestr, int *min ) ;
void	make_timestr( int min, BYTE *buf ) ;
void	make_timestr96( int min, BYTE *buf ) ;
void	fatal(BYTE *str ) ;
void	wcs_fatal( LPCTSTR str ) ;
int	process_cb( int (*p)( BYTE *b), BYTE *cb,int s, BYTE *t );
int	check_param( int index ) ;
int	set_bool(BYTE *buf, int if_null ) ;
void	copy_dirname( BYTE *dst,BYTE *src ) ;
void	__assertfail( char *__cond, char *__file, int __line ) ;
void	Puts(BYTE *buf ) ;
int	Kbhit( void ) ;
unsigned int	Getch( void ) ;
void	SendKey( WORD c ) ;

extern	int	Argc ;
extern	BYTE	*Argv[10] ;

extern	int	F_SaveMem ;
extern	int	F_noconv ;

extern	long	StrDataOfs ;
extern	int		StrNext ;
extern	WORD	StrSize ;
extern	HLOCAL	StrIdxHandle ;
extern	HLOCAL	StrPtrHandle ;
extern	int		Max_stridx ;	/* ˳ݤʸ */
extern	WORD	Max_strbuf ;	/* ˳ݤʸХåե */

extern	BYTE	EmptyStr[] ;

#ifdef __cplusplus
} ;
#endif
#endif	/* __LFUNC */
